//
//  ViewController.m
//  ChartViewCustomMarkers
//
//  Created by Developer Support on 6/18/14.
//  Copyright (c) 2014 Developer Support. All rights reserved.
//

#import "ViewController.h"
#import <IGChart/IGChart.h>
@interface DataModel : NSObject
@property (nonatomic, retain) NSString *label;
@property (nonatomic) float value1;
@property (nonatomic) float value2;
@property (nonatomic) float value3;
@end

@interface ViewController()
{
    IGChartView *_chartView;
    IGStackedSeriesDataSourceHelper *_stackedChartDataSourceHelper;
    IGLegend *_legend;
    NSMutableArray *_data;
    
}
@end

@implementation DataModel
@synthesize value1, value2, value3;
@end

NSInteger fragmentindex = -1;
@implementation ViewController

-(void)populateData
{
    _data = [[NSMutableArray alloc]init];
    for (int i=0; i<10; i++)
    {
        DataModel *item = [[DataModel alloc]init];
        item.value1 = arc4random() % 100;
        item.value2 = arc4random() % 100;
        item.value3 = arc4random() % 100;
        item.label = [NSString stringWithFormat:@"Label %d", i];
        [_data addObject:item];
    }
}
-(void)viewDidLoad
{
    [self populateData];
    CGRect bounds = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
    _chartView = [[IGChartView alloc] initWithFrame:bounds];
    _chartView.backgroundColor = [UIColor whiteColor];
    _stackedChartDataSourceHelper = [[IGStackedSeriesDataSourceHelper alloc]initWithData:_data fields:@[@"value1", @"value2", @"value3"]];
    IGStackedColumnSeries *ser = (IGStackedColumnSeries*)[_chartView addStackedSeriesForType:[IGStackedColumnSeries class] usingKey:@"series" withDataSource:_stackedChartDataSourceHelper firstAxisKey:@"xAxis" secondAxisKey:@"yAxis"];
    //_chartView.se
    _chartView.delegate = self;
    [self.view addSubview:_chartView];
   
}


- (UIView *)chartView:(IGChartView *)chartView viewForMarkerInSeries:(IGSeries *)series withItem:(NSObject *)item index:(NSInteger)index originalSourceItem:(NSObject *)originalSourceItem displayOptions:(IGMarkerDisplayOptions *)options
{
 
    UILabel *label = [[UILabel alloc] init];
    label.textAlignment = NSTextAlignmentLeft;
    
    IGStackedBarSeries *stackedseries = (IGStackedBarSeries*)series;
    NSInteger fragmentCount =stackedseries.series.count;
    
    if(index == 0)
    {
        fragmentindex ++;
        fragmentindex = fragmentindex % fragmentCount;
    }
    
    IGStackedFragmentSeries *fragment = stackedseries.series[fragmentindex];
   
    NSNumber *num = [item valueForKey:fragment.valueProperty];
    
    label.backgroundColor = [UIColor lightGrayColor];
    label.text = [NSString stringWithFormat:@"%.1f ", [num floatValue] ];
    label.layer.cornerRadius = 8.0;
    [label sizeToFit];
    
    CGRect viewBounds = CGRectMake(0, 0, label.bounds.size.width, label.bounds.size.height * 2);
    label.frame = CGRectMake(0, label.bounds.size.height, label.bounds.size.width, label.bounds.size.height);
    
    UIView *view = [[UIView alloc]initWithFrame:viewBounds];
    view.backgroundColor = [UIColor clearColor];
    [view addSubview:label];
    
    return view;
    return label;
}
@end
